<?php

define('SOFTACULOUS', 1);
define('SOFTMODULEVER', 1);

// To run forever
ignore_user_abort(true);
set_time_limit(0);

// Include the init file to be able to use Capsule class
require_once(dirname(dirname(dirname(__FILE__))).'/init.php');

//use the Capsule DBAL
use WHMCS\Database\Capsule;
include_once('sdk/webuzo_sdk.php');

// Get a web file with CURL
function _get_web_cfile($url, $time = 15, $error = ''){
	
	// Set the curl parameters.
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);

	// Turn off the server and peer verification (TrustManager Concept).
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $time);
	
	// Check the Header
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	
	// Get response from the server.
	$file = curl_exec($ch);
	
	return $file;
	
}//End of function

/**
* Prepare call for logo language sitename
* 
* @param        String logo $relid logo URL
* @param        String language $fieldid language for webuzo panel
* @param        String $sitname Sitname
* @return       boolean
*/
function prepare_call($ip, $logo = '', $language = '', $sitname = ''){
	
	//For testing 
	//echo $logo .'---'.$language.'---'. $sitname;
	
	// Prpare call for logo
	if(!empty($logo)) _get_web_cfile('https://'.$ip.':2005/install.php?preparelogo='.$logo, 2);
	
	// Prpare call for language
	if(!empty($language)) _get_web_cfile('https://'.$ip.':2005/install.php?language='.$language, 2);
	
	// Prpare call for lsitename
	if(!empty($sitname)) _get_web_cfile('https://'.$ip.':2005/install.php?sitename='.$sitname, 2);
	
	return true;
}

/**
* Update query
* 
* @param        array  $data Actual data
* @param        String $relid relid 
* @param        String $fieldid fieldid
* @param        String $final_done Complet proccess and append the data with 1|
* @return       boolean
*/	
function update_wuzoquery($data, $relid , $fieldid , $done = ''){
	
	if(!empty($done)){
		
		if($done == '1'){
		
			$status = (empty($data['status'])) ? "Server could not be configured due to some reason. Please contact Sales." : " ";
			
			// Mail message
			$message = "Hi,
	
Your Webuzo installed VPS is up and ready to use.
Here is the status of your VPS : ".$data['status']."

".$status ."

Regards,
Webuzo";
			
			// Mail
			@mail($data['email'], 'Status of your Webuzo VPS '.$data['ip'].' created from WHMCS', $message);
		
		}
	
		// End for search 
		$output = '1|'.serialize($data);
		
	}else{
		
		$output = serialize($data);
		
	}
	
	Capsule::update('UPDATE `tblcustomfieldsvalues` 
				SET `value` = :value 
				WHERE `relid` = :relid 
				AND `fieldid` = :fieldid',
				array(':value' => $output,
					':relid' => $relid,
					':fieldid' => $fieldid));
	return true;
	
}//End of function




// Get the id of webuzo custom field
$query = Capsule::select('SELECT `id` FROM `tblcustomfields` WHERE `fieldname` = :fieldname', 
					array(':fieldname' => 'Webuzo Status'));

$t_res = array();

foreach($query as $k => $v){
	$t_res[] = $v->id;
}

//print_r($t_res);				

$t_res = empty($t_res) ? array(-1) : $t_res;

// Get the data of webuzo custom field
$placeholders = str_repeat ('?, ',  count ($t_res) - 1) . '?';
$query = Capsule::select('SELECT * FROM `tblcustomfieldsvalues` WHERE `fieldid` IN ('.$placeholders.') 
						AND `value` NOT LIKE "1|%"', 
						$t_res);

if(count($query) > 0 ){
	
	for($i = 1; $i <= count($query); $i++){
		$record[$i] = (array) $query[$i];
		
		// If record is empty , vps is terminated
		if(empty($record[$i]['value'])){
			
			unset($record[$i]);
			
		}
	}

	//print_r($record);
	
	// Check if live 
	foreach($record as $k => $v){
		
		$c_data = unserialize($v['value']);
		
		//print_r($c_data);	
		
		// We enter if there is NO Lock 
		// OR
		// If there is a lock which is more than 10 minutes
		// and attemp is not more then 30
		if( ! (empty($c_data['is_lock']) || round((time() - $c_data['is_lock'])/60) < 10) ){
			
			continue;
			
		}
		
		// We still need to be sure that no other process is checking for this particular server
		// Hence we get the data of this row again
		$query = Capsule::select('SELECT * FROM `tblcustomfieldsvalues` WHERE `fieldid` = :fieldid 
					AND `relid` = :relid 
					AND `value` NOT LIKE "1|%"', 
					array(':fieldid' => $v['fieldid'],
						':relid' => $v['relid']));
		$rest = (array) $query[0];

		if(count($query) < 1){
			continue;
		}
			
		$data = unserialize($rest['value']);
		
		//print_r($data);
		
		// Again check the status
		if( ! (empty($data['is_lock']) || round((time() - $data['is_lock'])/60) < 10) ){		
			continue;
		}
		
		// Just for sefty
		if($data['count'] > 30 || empty($data['count'])){
			
			// End cron
			$data['count'] = 0;
			
			// Call update query function
			update_wuzoquery($data, $rest['relid'], $rest['fieldid'], 2);
			
			continue;
			
		}
		
		// Lock and update so that no other process tries this	
		$data['is_lock'] = time();
		
		// Call update query function
		update_wuzoquery($data, $rest['relid'] , $rest['fieldid']);
		
		// Just a status change on startup
		if($data['count'] == 1) $data['status'] = 'Running';
		
		// Add to the count
		$data['count'] = $data['count'] + 1;
		
		// Try to get the access of the installer
		$ret = _get_web_cfile('https://'.$data['ip'].':2005', 2);
		
		// Ok, we got the installer
		if(!empty($ret)){
			
			// End cron
			$data['count'] = 0;
			
			// Change status
			$data['status'] = 'Working';
			
			// Call update query function
			update_wuzoquery($data, $rest['relid'] , $rest['fieldid']);
						
			// Make an API call
			$webuzo = new Webuzo_API();
			
			echo "Configuring new VPS : ".$data['ip']." ... \n";
				
			// Do we need to install any Apps ?	
			
			if(!empty($data['apps'])){
				
				@define('SOFTACULOUS', 1);
	
				// Get the new apps.php
				eval(substr(file_get_contents('http://api.webuzo.com/apps.php'), 5));
				
				// Save the License KEY
				exec('echo "'.$license.'" > /usr/local/webuzo/tlicense', $out, $ret);
				
				$arch = trim(shell_exec('uname -m'));
				$arch = (preg_match('/64/is', $arch) ? 'x86_64' : 'x86');
				
				if(!is_dir('/var/softaculous/apps')){
					@mkdir('/var/softaculous/apps');
				}
				
				$prepareapps = explode(';', $data['apps']);
				$prepareapps = implode(',', $prepareapps);
				
				$chunk = explode(",", $prepareapps);
				
				foreach($apps as $kt => $vt){
					if(in_array($vt['softname'], $chunk)){
						
						// Apps are now downloaded lets install it.
						$ret = $webuzo->install_app($vt['aid']);
						
						if(empty($res['done'])){
							echo "Failed to install app : ".$vt['softname']."\n";
						}else{
							echo "App installed : ".$vt['softname']."\n";
						}
						
						/* // Download IT
						exec('/usr/bin/wget --no-check-certificate -N -O /var/softaculous/apps/'.$vt['softname'].'.zip "http://api.webuzo.com/giveapp.php?appid='.$vt['aid'].'&arch='.$arch.'&panel=webuzo&license='.$data['license'].'"', $out, $ret);
						
						// Make a Directory
						exec('mkdir /var/softaculous/apps/'.$vt['softname'], $out, $ret);
						
						// Unzip IT
						exec('cd /var/softaculous/apps/'.$vt['softname'].'; /usr/bin/unzip -o /var/softaculous/apps/'.$vt['softname'].'.zip', $out, $ret);
						
						// Remove the File
						exec('rm -rf /var/softaculous/apps/'.$vt['softname'].'.zip', $out, $ret); */
						
					}
					
				}
				
				//print_r($return);
			}
			
			// Prepare call for logo / sitename / language
			echo "Setting logo, language, name ... \n";
			prepare_call($data['ip'], $data['logo'], $data['language'], $data['site_name']);
			echo "Finished setting logo, language, name\n";
			
			// Change hostname before creating user
			$ret = $webuzo->set_panel_config($data['ip'], 'server_'.$data['host']);
			
			if(empty($res['done'])){
				echo "Failed to set hostname ... \n";
			}
			
			echo "Creating default user ... \n";
			
			$pass = generateRandStr(8);
			
			// First we need to create user to install script
			$res = $webuzo->create_user($data['user'], $data['host'], $pass, $data['email'], $plan = '', $pData = []);
			
			//$res = unserialize($res);
			
			// Was it successful ?
			if(!empty($res['done'])){
				
				echo "Default User created : ".$data['ip']."\n";
				
				// Do we need to install a Script - We use the AUTO INSTALL method
				if(!empty($data['sid'])){
				
					echo "Installing Script ".$data['sid']." on ".$data['ip']."\n";
					
					// URL to login
					$login = 'https://'.rawurlencode('soft').':'.rawurlencode($pass).'@'.$data['ip'].':2003/softaculous/index.php?act=software&soft='.$data['sid'].'&autoinstall='.rawurlencode(base64_encode(serialize($data[$data['sid']])));
					
					//echo $login;					
					//print_r($data[$data['sid']]);
					
					// Set the curl parameters
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, $login);
				
					// Turn off the server and peer verification (TrustManager Concept).
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
					curl_setopt($ch, CURLOPT_HEADER, FALSE);
					
					// Is there a Cookie
					if(!empty($cookie)){
						curl_setopt($ch, CURLOPT_COOKIESESSION, true);
						curl_setopt($ch, CURLOPT_COOKIE, $cookie);
					}
			
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				
					// Get response from the server
					$resp = curl_exec($ch);
					
					// Close the curle
					curl_close($ch);
					
					// Was there any error ?
					if($resp == 'installed'){
											
						// Change status
						$data['status'] = 'Webuzo Configuration and Script installation done successfully';
						
						// Log it
						echo "Webuzo Configuration and Script installation done successfully on ".$data['ip']."\n";
					
					// Error
					}else{
				
						echo "Error : Webuzo configured but error occured while installing Script\n";
						echo "Error : $resp\n";
						
						// Change status
						$data['status'] = 'Error : Webuzo configured but error occured while installing Script';
											
					}
					
				}else{
									
					// Change status
					$data['status'] = 'Webuzo Configured successfully';
					
				}
			
			// Looks like there was an error
			}else{	
			
				// Change status
				$data['status'] = 'Error: Some error occurred while creating default user : '.$data['user'].' - '.implode(',', $res['error']);
			
				echo $data['status']."\n";
				print_r($res);
							
			}
			
		}// End of install.php IF
		
		// Check count is not more then maximum attempt ?
		if(!empty($data['count']) && $data['count'] >= 31 ){
			
			$data['status'] = 'Error: Too much time for VPS to come live';
			
			// End cron 
			$data['count'] = 0;
			
		}
		
		// Free the lock
		$data['is_lock'] = 0;
		
		// Check the counter if complete then append with 1|
		if(empty($data['count'])){
			
			// Call update query function
			update_wuzoquery($data, $rest['relid'] , $rest['fieldid'] , 1);
		
		// Should we mail the entire status?
		}else{
			
			// Call update query function
			update_wuzoquery($data, $rest['relid'] , $rest['fieldid']);
			
		}		
	}	
}

function generateRandStr($length, $special = 0){
	
	global $globals, $softpanel;
	
	$randstack = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
	
	$specialchars = array('!', '[', ']', '(', ')', '.', '-', '@');
	
	$randstr = '';

	while(strlen($randstr) < $length){
		
		$randstr .= $randstack[array_rand($randstack)];
		
		if(!empty($special) && strlen($randstr) < $length && (strlen($randstr)%2 == 0)){
			$randstr .= $specialchars[array_rand($specialchars)];
		}
		
	}
	
	return str_shuffle($randstr);

}

?>
